/*******************************************************************************
 * Copyright (c) 2009 Progress Software, Inc.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *******************************************************************************/
#include "hawtjni.h"
#include "hawtjni-example_stats.h"

#ifdef NATIVE_STATS

int Example_nativeFunctionCount = 27;
int Example_nativeFunctionCallCount[27];
char * Example_nativeFunctionNames[] = {
	"callmeback",
	"foowork",
	"free",
	"init",
	"malloc",
	"memmove__JJJ",
	"memmove__JLtest_Example_00024foo_2J",
	"memmove__J_3BJ",
	"memmove__J_3CJ",
	"memmove__J_3DJ",
	"memmove__J_3FJ",
	"memmove__J_3IJ",
	"memmove__J_3JJ",
	"memmove__J_3SJ",
	"memmove__Ltest_Example_00024foo_2JJ",
	"memmove___3BJJ",
	"memmove___3B_3CJ",
	"memmove___3CJJ",
	"memmove___3DJJ",
	"memmove___3FJJ",
	"memmove___3IJJ",
	"memmove___3I_3BJ",
	"memmove___3JJJ",
	"memmove___3SJJ",
	"memset",
	"print_1foo",
	"strlen",
};

#define STATS_NATIVE(func) Java_org_fusesource_hawtjni_runtime_NativeStats_##func

JNIEXPORT jint JNICALL STATS_NATIVE(Example_1GetFunctionCount)
	(JNIEnv *env, jclass that)
{
	return Example_nativeFunctionCount;
}

JNIEXPORT jstring JNICALL STATS_NATIVE(Example_1GetFunctionName)
	(JNIEnv *env, jclass that, jint index)
{
	return (*env)->NewStringUTF(env, Example_nativeFunctionNames[index]);
}

JNIEXPORT jint JNICALL STATS_NATIVE(Example_1GetFunctionCallCount)
	(JNIEnv *env, jclass that, jint index)
{
	return Example_nativeFunctionCallCount[index];
}

#endif
#ifdef NATIVE_STATS

int foo_nativeFunctionCount = 1;
int foo_nativeFunctionCallCount[1];
char * foo_nativeFunctionNames[] = {
	"init",
};

#define STATS_NATIVE(func) Java_org_fusesource_hawtjni_runtime_NativeStats_##func

JNIEXPORT jint JNICALL STATS_NATIVE(foo_1GetFunctionCount)
	(JNIEnv *env, jclass that)
{
	return foo_nativeFunctionCount;
}

JNIEXPORT jstring JNICALL STATS_NATIVE(foo_1GetFunctionName)
	(JNIEnv *env, jclass that, jint index)
{
	return (*env)->NewStringUTF(env, foo_nativeFunctionNames[index]);
}

JNIEXPORT jint JNICALL STATS_NATIVE(foo_1GetFunctionCallCount)
	(JNIEnv *env, jclass that, jint index)
{
	return foo_nativeFunctionCallCount[index];
}

#endif
#ifdef NATIVE_STATS

int point_nativeFunctionCount = 1;
int point_nativeFunctionCallCount[1];
char * point_nativeFunctionNames[] = {
	"init",
};

#define STATS_NATIVE(func) Java_org_fusesource_hawtjni_runtime_NativeStats_##func

JNIEXPORT jint JNICALL STATS_NATIVE(point_1GetFunctionCount)
	(JNIEnv *env, jclass that)
{
	return point_nativeFunctionCount;
}

JNIEXPORT jstring JNICALL STATS_NATIVE(point_1GetFunctionName)
	(JNIEnv *env, jclass that, jint index)
{
	return (*env)->NewStringUTF(env, point_nativeFunctionNames[index]);
}

JNIEXPORT jint JNICALL STATS_NATIVE(point_1GetFunctionCallCount)
	(JNIEnv *env, jclass that, jint index)
{
	return point_nativeFunctionCallCount[index];
}

#endif
#ifdef NATIVE_STATS

int ObjectiveCExample_nativeFunctionCount = 4;
int ObjectiveCExample_nativeFunctionCallCount[4];
char * ObjectiveCExample_nativeFunctionNames[] = {
	"_00024__JJ",
	"_00024__JJLjava_lang_String_2",
	"objc_1getClass",
	"sel_1registerName",
};

#define STATS_NATIVE(func) Java_org_fusesource_hawtjni_runtime_NativeStats_##func

JNIEXPORT jint JNICALL STATS_NATIVE(ObjectiveCExample_1GetFunctionCount)
	(JNIEnv *env, jclass that)
{
	return ObjectiveCExample_nativeFunctionCount;
}

JNIEXPORT jstring JNICALL STATS_NATIVE(ObjectiveCExample_1GetFunctionName)
	(JNIEnv *env, jclass that, jint index)
{
	return (*env)->NewStringUTF(env, ObjectiveCExample_nativeFunctionNames[index]);
}

JNIEXPORT jint JNICALL STATS_NATIVE(ObjectiveCExample_1GetFunctionCallCount)
	(JNIEnv *env, jclass that, jint index)
{
	return ObjectiveCExample_nativeFunctionCallCount[index];
}

#endif
